#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct fenwick {
  int n;
  vector<int> f;
  fenwick(int _n) : n(_n), f(_n) {}
  void add(int x, int y) {
    for (; x < n; x |= x + 1) f[x] += y;
  }
  int get(int x) {
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1) res += f[x];
    return res;
  }
};

int main() {
  int n, q;
  while (scanf("%d%d", &n, &q) == 2) {
    vector<int> a(n);
    for (int i = 0; i < n; i++) scanf("%d", &a[i]);

    fenwick f(n + 1);
    set<int> st;
    for (int i = 0; i < n; i++) st.insert(i);

    while (q--) {
      int t;
      scanf("%d", &t);
      if (t == 1) {
        int l, r;
        scanf("%d%d", &l, &r);
        f.add(l - 1, +1);
        f.add(r, -1);
      } else {
        int l, r, x;
        scanf("%d%d%d", &l, &r, &x);
        l--; r--;
        int res = -1;
        while (1) {
          auto it = st.lower_bound(l);
          if (it == st.end() || *it > r) break;
          int id = *it;
          int y = a[id] - f.get(id);
          if (y <= 1) st.erase(it);
          else x /= y;
          if (x == 0) {
            res = id + 1;
            break;
          }
          l = id + 1;
        }
        printf("%d\n", res);
      }
    }
  }
}
