#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1'000'000'000;

vector<int> s;
vector<int> it1, mod2;
vector<pair<int, int>> it2;

void init(int u, int L, int R) {
    if (R - L == 1) {
        it1[u] = s[L] == 1 ? INF : L;
        it2[u] = {s[L] == 1 ? INF : s[L], L};
        return;
    }
    int M = (L + R) / 2;
    init(2 * u + 1, L, M);
    init(2 * u + 2, M, R);
    it1[u] = min(it1[2 * u + 1], it1[2 * u + 2]);
    it2[u] = min(it2[2 * u + 1], it2[2 * u + 2]);
}

void push(int u) {
    it2[2 * u + 1].first += mod2[u];
    it2[2 * u + 2].first += mod2[u];
    mod2[2 * u + 1] += mod2[u];
    mod2[2 * u + 2] += mod2[u];
    mod2[u] = 0;
}

void mod(int u, int L, int R, int i, int v) {
    if (R - L == 1) {
        it1[u] = v == 1 ? INF : L;
        it2[u].first = v == 1 ? INF : s[L];
        return;
    }
    int M = (L + R) / 2;
    push(u);
    if (i < M) {
        mod(2 * u + 1, L, M, i, v);
    } else {
        mod(2 * u + 2, M, R, i, v);
    }
    it1[u] = min(it1[2 * u + 1], it1[2 * u + 2]);
    it2[u] = min(it2[2 * u + 1], it2[2 * u + 2]);
}

int val(int u, int L, int R, int i) {
    if (R - L == 1) {
        return it2[u].first;
    }
    int M = (L + R) / 2;
    push(u);
    if (i < M) {
        return val(2 * u + 1, L, M, i);
    } else {
        return val(2 * u + 2, M, R, i);
    }
}

int ask(int u, int L, int R, int l, int r) {
    if (L >= r || l >= R) {
        return INF;
    }
    if (l <= L && R <= r) {
        return it1[u];
    }
    int M = (L + R) / 2;
    return min(ask(2 * u + 1, L, M, l, r), ask(2 * u + 2, M, R, l, r));
}

void add(int u, int L, int R, int l, int r, int v) {
    if (l >= R || L >= r) {
        return;
    }
    if (l <= L && R <= r) {
        it2[u].first += v;
        mod2[u] += v;
        return;
    }
    push(u);
    int M = (L + R) / 2;
    add(2 * u + 1, L, M, l, r, v);
    add(2 * u + 2, M, R, l, r, v);
    it2[u] = min(it2[2 * u + 1], it2[2 * u + 2]);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    it1.resize(4 * n);
    it2.resize(4 * n);
    mod2.resize(4 * n);
    init(0, 0, n);

    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r;
            cin >> l >> r;
            l--;
            add(0, 0, n, l, r, -1);
            while (it2[0].first == 1) {
                mod(0, 0, n, it2[0].second, 1);
            }
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            l--;
            l = ask(0, 0, n, l, r);
            while (l < r) {
                int v = val(0, 0, n, l);
                x /= v;
                if (x == 0) {
                    cout << l + 1 << "\n";
                    break;
                }
                l = ask(0, 0, n, l + 1, r);
            }
            if (x != 0) {
                cout << -1 << "\n";
            }
        }
    }

    return 0;
}
