#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include "testlib.h"
#include <set>

using namespace std;

const int MAXN = (int)1e6;

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int ans = atoi(argv[2]);
    int maxD = atoi(argv[3]);

    vector<pair<int, int>> seg;
    vector<int> sep(ans - 1);
    for (int i = 0; i < ans - 1; i++) {
        sep[i] = rnd.next(1, n);
    }

    sep.push_back(1), sep.push_back(n + 1);
    sort(sep.begin(), sep.end());

    for (int i = 0; i < ans; i++) {
        if (sep[i] != sep[i + 1])
            seg.push_back({sep[i], sep[i + 1] - 1});
    }


    vector<int> nums(seg.size());
    for (size_t i = 0; i < seg.size(); i++) {
        nums[i] = rnd.next(1, maxD);
    }

    sort(nums.begin(), nums.end());

    vector<int> A(n + 1);
    for (size_t i = 0; i < seg.size(); i++) {
        int l = seg[i].first, r = seg[i].second;
        //cerr << l << ' ' << r << endl;
        A[l] = nums[i], A[r] = nums[i]; 
    }

    for (int i = 0; i < n; i++) {
        if (!A[i]) A[i] = rnd.next(1, maxD);
    }

    cout << n << '\n' << A[1];
    for (int i = 2; i <= n; i++) {
        cout << ' ' << A[i];
    }
    cout << '\n';
    return 0;
 }