#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}
const int MAXN = (int)1e6 + 5;

int dp[MAXN], p[MAXN];
int pr[MAXN], A[MAXN];
int sum[MAXN];

int solve() {
	int n; cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> A[i];
		p[A[i]] = n + 1;
	}

	for (int i = 0; i + 1 < n; i++) {
		if (A[i] == A[i + 1]) sum[i] += 1;
		sum[i + 1] += sum[i];
	}

	fill(dp, dp + n + 1, INF);
	fill(pr, pr + n + 1, -1);

	dp[n] = 0;
	dp[n + 1] = INF;

	for (int i = n - 1; i >= 0; i--) {
		if (dp[p[A[i]]] >= dp[i + 1] && (i + 1 == n || A[i] < A[i + 1])) 
			p[A[i]] = i + 1;
		if (dp[p[A[i]]] != INF) {
			int x = sum[p[A[i]] - 1] - (i ? sum[i - 1] : 0);
			dp[i] = dp[p[A[i]]] + (x < p[A[i]] - i - 1);
			pr[i] = p[A[i]];
		} 
	}

	if (dp[0] == INF) cout << -1, exit(0);
	cout << dp[0] << '\n';

	int i = 0;
	while (pr[i] != -1) {
		int x = sum[pr[i] - 1] - (i ? sum[i - 1] : 0);
		if (x < pr[i] - i - 1)
			cout << i + 1 << ' ' << pr[i] << '\n';
		i = pr[i];
	}

	return 0;
}