#include "testlib.h"

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <ctime>
#include <climits>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <bitset>
#include <utility>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < int(n); i++)

using namespace std;

const int N = 3e5 + 7;

vector <int> gr[N];
bool vis[N];

int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int sz = atoi(argv[3]);
    set <pair <int, int> > qq;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int t = 0; t < 4; t++)
            {
                int x = i + dx[t], y = j + dy[t];
                if (x >= 0 && x < n && y >= 0 && y < m)
                {
                    int a = i * m + j;
                    int b = x * m + y;
                    qq.insert({a, b});
                    gr[a].push_back(b);
                }
            }
        }
    }
    vector <int> perm(n * m);
    for (int i = 0; i < n * m; i++) perm[i] = i;
    shuffle(perm.begin(), perm.end());
    vector <pair <int, int> > e;
    for (int i : perm)
    {
        shuffle(gr[i].begin(), gr[i].end());
        for (int j : gr[i])
        {
            if (!vis[i] && !vis[j] && i < j)
            {
                vis[i] = true;
                vis[j] = true;
                e.push_back({i, j});
            }
        }
    }
    shuffle(e.begin(), e.end());
    while (e.size() > sz) e.pop_back();
    vector <int> kek;
    for (auto c : e) kek.push_back(c.first), kek.push_back(c.second);
    map <pair <int, int>, pair <int, int> > mp;
    while (true)
    {
        bool bad = false;
        shuffle(kek.begin(), kek.end());
        for (auto c : e) qq.erase(c);
        for (int i = 0; i < (int) kek.size(); i += 2)
        {
            if (qq.count({min(kek[i], kek[i + 1]), max(kek[i], kek[i + 1])}))
            {
                bad = true;
            }
        }
        for (auto c : e) qq.insert(c);
        if (bad) continue;
        sz = 0;
        for (auto c : e)
        {
            pair <int, int> uk = {kek[sz], kek[sz+1]};
            mp[c] = uk;
            sz+=2;
        }
        break;
    }
    cout << n << ' ' << m << '\n';
    for (int i = 0; i < n * m; i++)
    {
        for (int j : gr[i])
        {
            if (i < j)
            {
                if (mp.count({i, j}))
                {
                    cout << mp[{i, j}].first + 1 << ' ' << mp[{i, j}].second + 1 << '\n';
                }
                else
                {
                    if (rnd.next(0, 1))
                        cout << i + 1 << ' ' << j + 1 << '\n';
                    else
                        cout << j + 1 << ' ' << i + 1 << '\n';
                }
            }
        }
    }
    return 0;
}
