#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 3e5 + 7;

vector <int> g[N];
vector <int> gr[N];
vector <int> solve[N];
vector <int> dists[N];

int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int edges = n * (m - 1) + m * (n - 1);
    for (int it = 0; it < edges; it++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector <int> verts;
    for (int i = 0; i < n * m; i++)
    {
        if ((int) g[i].size() > 4)
        {
            cout << "No\n";
            return 0;
        }
        if ((int) g[i].size() == 2)
        {
            verts.push_back(i);
        }
    }
    if ((int) verts.size() != 4)
    {
        cout << "No\n";
        return 0;
    }
    for (int v : verts)
    {
        queue <int> q;
        q.push(v);
        vector <int> dist(n * m, -1);
        dist[v] = 0;
        while (!q.empty())
        {
            int v = q.front();
            q.pop();
            for (int to : g[v])
            {
                if (dist[to] == -1)
                {
                    dist[to] = dist[v] + 1;
                    q.push(to);
                }
            }
        }
        for (int i = 0; i < n * m; i++)
        {
            solve[i].push_back(dist[i]);
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int t = 0; t < 4; t++)
            {
                int x = i + dx[t], y = j + dy[t];
                if (x >= 0 && x < n && y >= 0 && y < m)
                {
                    int a = i * m + j;
                    int b = x * m + y;
                    gr[a].push_back(b);
                }
            }
        }
    }
    verts.clear();
    verts.push_back(0 * m + 0);
    verts.push_back(0 * m + m - 1);
    verts.push_back((n - 1) * m + 0);
    verts.push_back((n - 1) * m + m - 1);
    vector <pair <vector <int>, int> > my_g;
    for (int i = 0; i < n * m; i++)
    {
        my_g.push_back({solve[i], i});
    }
    sort(my_g.begin(), my_g.end());
    do
    {
        for (int i = 0; i < n * m; i++)
        {
            dists[i].clear();
        }
        for (int v : verts)
        {
            queue <int> q;
            q.push(v);
            vector <int> dist(n * m, -1);
            dist[v] = 0;
            while (!q.empty())
            {
                int v = q.front();
                q.pop();
                for (int to : gr[v])
                {
                    if (dist[to] == -1)
                    {
                        dist[to] = dist[v] + 1;
                        q.push(to);
                    }
                }
            }
            for (int i = 0; i < n * m; i++)
            {
               dists[i].push_back(dist[i]);
            }
        }
        vector <pair <vector <int>, int> > his_g;
        for (int i = 0; i < n * m; i++)
        {
            his_g.push_back({dists[i], i});
        }
        sort(his_g.begin(), his_g.end());
        vector <int> perm(n * m);
        bool bad = false;
        for (int i = 0; i < n * m; i++)
        {
            if (his_g[i].first != my_g[i].first)
            {
                bad = true;
                break;
            }
            perm[my_g[i].second] = his_g[i].second;
        }
        if (!bad)
        {
            set <pair <int, int> > q;
            for (int i = 0; i < n * m; i++)
            {
                for (int x : gr[i])
                {
                    q.insert({i, x});
                }
            }
            for (int i = 0; i < n * m; i++)
            {
                for (int x : g[i])
                {
                    if (!q.count({perm[i], perm[x]}))
                    {
                        bad = true;
                        break;
                    }
                }
            }
            if (!bad)
            {
                cout << "Yes\n";
                return 0;
            }
        }
    }
    while (next_permutation(verts.begin(), verts.end()));
    cout << "No\n";
    return 0;
}
