#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 3e5 + 7;

vector <int> g[N];
vector <int> gr[N];
vector <int> solve[N];
vector <int> dists[N];

int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

bool u[N];

void dfs(int v)
{
    u[v] = true;
    for (int to : g[v])
    {
        if (!u[to])
        {
            dfs(to);
        }
    }
}

int main()
{
#ifdef ONPC
  //  freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int edges = n * (m - 1) + m * (n - 1);
    for (int it = 0; it < edges; it++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector <int> cnt(5);
    for (int i = 0; i < n * m; i++)
    {
        if (g[i].size() <= 1 || g[i].size() > 4)
        {
            cout << "No\n";
            return 0;
        }
        cnt[g[i].size()]++;
    }
    if (cnt[2] != 4 || cnt[3] != (n + m - 4) * 2)
    {
        cout << "No\n";
        return 0;
    }
    dfs(0);
    for (int i = 0; i < n * m; i++)
    {
        if (!u[i])
        {
            cout << "No\n";
            return 0;
        }
    }
    cout << "Yes\n";
}
