#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

void no() { exit(0 * puts("No")); }

vector<int> bfs(int s, int t, int len, vector<vector<int>> &E, vector<int> &deg) {
	vector<int> d(len, (int)1e9), p(len, -1);
	queue<int> q;
	
	d[s] = 0, q.push(s);
	while (q.size()) {
		int v = q.front();
		q.pop();
		if (v == t) break;
		for (int to : E[v]) if (deg[to] < 4) {
			if (d[to] > d[v] + 1)
				d[to] = d[v] + 1, p[to] = v, q.push(to);
		}
	}
	vector<int> path;
	for (int v = t; v != -1; v = p[v]) path.push_back(v);
	reverse(path.begin(), path.end());
	return path;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	vector<vector<int> > E(n * m);
	
	int len = n * (m - 1) + (n - 1) * m;
	vector<int> deg(n * m);
	vector<int> used(n * m);
	
	E.resize(n * m);
	
	for (int i = 0; i < len; i++) {
		int a, b;
		cin >> a >> b;
		E[a - 1].push_back(b - 1);
		E[b - 1].push_back(a - 1);
		deg[a - 1]++, deg[b - 1]++;
	}
	
	set<pair<int, int> > S;
	for (int i = 0; i < n * m; i++) S.insert({ deg[i], i });
	
	while (S.size()) {
		vector<int> cur, T;
		while (S.size() && S.begin()->first < 4) {
			cur.push_back(S.begin()->second);
			S.erase(S.begin());
		}	
		
		if (cur.empty()) no();
		if (S.empty()) {
			int cnt2 = 0, cnt1 = 0;
			for (int v : cur) {
				if (deg[v] == 2) cnt2++;
				if (deg[v] == 1) cnt1++;
			}
			
			if (cnt2 == 4) {
				vector<int> curC;
				for (int v : cur) if (deg[v] == 2) curC.push_back(v);
				
				vector<int> path1, path2;
				for (int j = 1; j < 4; j++) {
					path1 = bfs(curC[0], curC[j], n * m, E, deg);
					if ((int)path1.size() == (int)cur.size() / 2) {
						swap(curC[1], curC[j]);
						if (bfs(curC[0], curC[2], n * m, E, deg).size() > 2) swap(curC[2], curC[3]);
						path2 = bfs(curC[2], curC[3], n * m, E, deg);
						break;
					}
				}
				
				if (path1.size() != path2.size()) no();
				
				for (int it = 0; it < 2; it++) {
    				for (int i = 0; i < (int)path1.size(); i++) {

    					int v = path1[i];
    					int t1 = 0, t2 = 0, t3 = 0;
    					int pr = -1, nx = -1, op = path2[i];
    					if (i > 0) pr = path1[i - 1];
    					if (i + 1 < (int)path1.size()) nx = path1[i + 1];
    					
    					for (int to : E[v]) if (deg[to] < 4) {
    						if (to == pr) t1++;
    						else if (to == nx) t2++;
    						else if (to == op) t3++;
    						else no();
    					}
    					if (!(t3 == 1 && (pr == -1 || t1 == 1) && (nx == -1 || t2 == 1))) no();
    				}
    				swap(path1, path2);
				}
				cout << "Yes\n";
				return 0;
			}
		}
		
		int cnt = 0;
		function<void(int)> dfs = [&](int v)->void {
			used[v] = 1;
			T.push_back(v);
			cnt++;
			for (int to : E[v]) if (deg[to] < 4) {
				if (!used[to]) dfs(to);
			}
		};
		
		
		dfs(cur[0]);
		
		if (cnt != (int)cur.size()) no();
		
		if (cur.size() > 1) {
			int cp = 0;
    		for (int i = 0; i < (int)T.size(); i++) {
    			int pr = (i ? i - 1 : (int)T.size() - 1);
    			int nx = (i + 1 < (int)T.size() ? i + 1 : 0);
    			int v = T[i];
    			int t1 = 0, t2 = 0, t3 = 0;
    			for (int to : E[v]) if (deg[to] < 4) {
    				if (to == T[pr]) t1++;
    				else if (to == T[nx]) t2++;
    				else t3++;
    			}
    			if (t1 != 1 || t2 != 1) {
    				if (S.empty() && (t1 + t2 + t3) == 1) cp++;
    				else no();
    			}
    		}
    		if (S.empty() && cp != 2 && cp != 0) no();
		}
		for (int v : cur) deg[v] = (int)1e9;
		for (int v : cur) {
			for (int to : E[v]) if (!used[to]) {
				S.erase({ deg[to], to });
				deg[to]--;
				S.insert({ deg[to], to });
			}
		}
	}
	cout << "Yes\n";
	return 0;
}
