#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    vector<vector<int>> col(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            col[i][j] = ((i + j) & 1);
            a[i] += col[i][j];
        }
    }

    while (q--) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x] -= col[x][y];
        col[x][y] = 1 - col[x][y];
        a[x] += col[x][y];

        int best = n * m;
        int cur = 0;
        for (int i = 0; i < n; i++) {
            cur += a[i];
        }
        best = min(best, cur);
        for (int i = 0; i < n; i++) {
            cur -= a[i];
            cur += m - a[i];
            best = min(best, cur);
        }

        cout << best << "\n";
    }

    return 0;
}